; 

    .486                      ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    include \masm32\macros\macros.asm

    TBUTNSTRUCT STRUCT
      txtcolor dd ?
      txtalign dd ?
      fonthndl dd ?
    TBUTNSTRUCT ENDS

    txtbutn      PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    txtbutn_proc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .code       ; code section

; 

txtbutn proc ptxt:DWORD,instance:DWORD,parent:DWORD,
             classname:DWORD,cursor:DWORD,tx:DWORD,
             ty:DWORD,wd:DWORD,ht:DWORD,ID:DWORD,pcst:DWORD

    LOCAL hndl  :DWORD
    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
    mrm wc.lpfnWndProc,    OFFSET txtbutn_proc
    mov wc.cbClsExtra,     40
    mov wc.cbWndExtra,     40
    mrm wc.hInstance,      instance
    mrm wc.hbrBackground,  rv(GetStockObject,HOLLOW_BRUSH)
    mov wc.lpszMenuName,   NULL
    mrm wc.lpszClassName,  classname
    mrm wc.hIcon,          NULL
    mrm wc.hCursor,        cursor
    mrm wc.hIconSm,        NULL

    invoke RegisterClassEx, ADDR wc

    fn CreateWindowEx,WS_EX_LEFT or WS_EX_TRANSPARENT, \
                      classname,ptxt,WS_CHILD, \
                      tx,ty,wd,ht,parent,ID, \
                      instance,NULL
    mov hndl, eax
    invoke ShowWindow,hndl,SW_SHOW
    invoke UpdateWindow,hndl

    push esi
    mov esi, pcst
    invoke SetWindowLong,hndl,0,(TBUTNSTRUCT PTR [esi]).txtcolor     ; text colour
    invoke SetWindowLong,hndl,4,(TBUTNSTRUCT PTR [esi]).fonthndl     ; font handle
    invoke SetWindowLong,hndl,8,(TBUTNSTRUCT PTR [esi]).txtalign     ; text alignment
    pop esi

    mov eax, hndl

    ret

txtbutn endp

; 

txtbutn_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL parent :DWORD
    LOCAL ID     :DWORD
    LOCAL hDC    :DWORD
    LOCAL pbuf   :DWORD
    LOCAL rct    :RECT
    LOCAL ps     :PAINTSTRUCT
    LOCAL pt     :POINT
    LOCAL buffer[128]:BYTE
    LOCAL hOld   :DWORD
    LOCAL DT_STYLE :DWORD

    switch uMsg
      case WM_LBUTTONDOWN

        push esi
        mov hDC, rv(GetDC,hWin)
        invoke SetBkMode,hDC,TRANSPARENT
        mov pbuf, ptr$(buffer)
        invoke GetWindowText,hWin,pbuf,128
        invoke GetClientRect,hWin,ADDR rct

        mov esi, rv(GetWindowLong,hWin,4)
        test esi, esi
        jz @F
        mov hOld, rv(SelectObject,hDC,esi)
      @@:

        call getstyle

        invoke SetTextColor,hDC,00000000h
        fn DrawText,hDC,pbuf,-1,ADDR rct,DT_STYLE

        add rct.left, 1
        add rct.top, 1
        add rct.right, 1
        add rct.bottom, 1
        invoke SetTextColor,hDC,rv(GetWindowLong,hWin,0)
        fn DrawText,hDC,pbuf,-1,ADDR rct,DT_STYLE

        mov esi, rv(GetWindowLong,hWin,0)
        test esi, esi
        jz @F
        invoke SelectObject,hDC,hOld
      @@:

        mov ID, rv(GetWindowLong,hWin,GWL_ID)
        invoke PostMessage,rv(GetParent,hWin),WM_COMMAND,ID,1
        fn SetCapture,hWin
        invoke ReleaseDC,hWin,hDC
        pop esi

      case WM_LBUTTONUP
        invoke GetClientRect,hWin,ADDR rct
        movzx eax, WORD PTR [ebp+20]
        movzx ecx, WORD PTR [ebp+22]
        .if eax < rct.right && ecx < rct.bottom
          .if rv(GetCapture) == hWin
            mov ID, rv(GetWindowLong,hWin,GWL_ID)
            invoke PostMessage,rv(GetParent,hWin),WM_COMMAND,ID,0
          .endif
        .endif
        invoke ReleaseCapture
        call refresh

      case WM_MOVE
        call refresh

      case WM_PAINT
        push esi
        mov hDC, rv(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke SetBkMode,hDC,TRANSPARENT
        mov pbuf, ptr$(buffer)
        invoke GetWindowText,hWin,pbuf,128

        mov esi, rv(GetWindowLong,hWin,4)
        test esi, esi
        jz @F
        mov hOld, rv(SelectObject,hDC,esi)
      @@:

        invoke GetClientRect,hWin,ADDR rct
        add rct.left, 1
        add rct.top, 1
        add rct.right, 1
        add rct.bottom, 1

        call getstyle

        invoke SetTextColor,hDC,00000000h
        fn DrawText,hDC,pbuf,-1,ADDR rct,DT_STYLE

        invoke GetClientRect,hWin,ADDR rct
        invoke SetTextColor,hDC,rv(GetWindowLong,hWin,0)
        fn DrawText,hDC,pbuf,-1,ADDR rct,DT_STYLE

        mov esi, rv(GetWindowLong,hWin,4)
        test esi, esi
        jz @F
        invoke SelectObject,hDC,hOld
      @@:

        invoke EndPaint,hWin,ADDR ps
        pop esi

    endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

  getstyle:
    switch rv(GetWindowLong,hWin,8)
      case -1
        mov DT_STYLE, DT_LEFT or DT_VCENTER or DT_NOCLIP or DT_SINGLELINE
      case 0
        mov DT_STYLE, DT_CENTER or DT_VCENTER or DT_NOCLIP or DT_SINGLELINE
      case 1
        mov DT_STYLE, DT_RIGHT or DT_VCENTER or DT_NOCLIP or DT_SINGLELINE
      default
        mov DT_STYLE, DT_CENTER or DT_VCENTER or DT_NOCLIP or DT_SINGLELINE
    endsw
    retn

  refresh:
    mov parent, rv(GetParent,hWin)
    invoke GetClientRect,hWin,ADDR rct
    invoke ClientToScreen,hWin,ADDR rct.left
    invoke ClientToScreen,hWin,ADDR rct.right
    invoke ScreenToClient,parent,ADDR rct.left
    invoke ScreenToClient,parent,ADDR rct.right
    invoke InvalidateRect,parent,ADDR rct,TRUE
    retn

txtbutn_proc endp

; 

end
